stages:
    - dependencies
    - test
    - build
    - deploy

    - build-docs
    - deploy-docs

variables:
    IMAGE_NAME: registry.gitlab.com/lorenzocalamandrei.dy/gitlab-ci-examples/my-image

image: alpine:latest

download-dependencies:
    stage: dependencies
    script:
        - mkdir dependencies
        - echo "My Dependencies..." > dependencies/deps.txt
    artifacts:
        expire_in: 30 days
        paths:
            - dependencies

test-dependencies:
    stage: test
    script:
        - ls -la dependencies
        - cat dependencies/deps.txt

build:
    image: docker:stable
    services:
        - docker:dind
    stage: build
    before_script:
        - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    script:
        - docker build --tag $IMAGE_NAME:$CI_COMMIT_SHORT_SHA -f Dockerfile .
        - docker push $IMAGE_NAME:$CI_COMMIT_SHORT_SHA

deploy:
    stage: deploy
    script:
        - echo "Deploy..."

pages:
    stage: build-docs
    script:
        - mv dependencies public
    artifacts:
        expire_in: 30 days
        paths:
            - public
